Bug 242828 - [QLogic 5.1 bug] qla4xxx: Fix overrun/underrun handling and HBA online cond.
[QLogic 5.1 bug] qla4xxx: Fix overrun/underrun handling and HBA online cond.
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: kernel (Show other bugs)
5.1
All Linux
urgent Severity urgent
: ---
: ---
Assigned To: Mike Christie
Martin Jenner
: OtherQA
Depends On:
Blocks: 216989 217104
  Show dependency treegraph
 
Reported: 2007-06-05 21:36 EDT by David Somayajulu
Modified: 2009-06-19 18:44 EDT (History)
11 users (show)

See Also:
Fixed In Version: RHBA-2007-0959
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-11-07 14:51:45 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
patch to fix overrun/underrun handling (3.19 KB, patch)
2007-06-05 21:36 EDT, David Somayajulu
no flags Details | Diff
Fix data overrun/underrun handling, also set AF_ONLINE condition fix. (4.91 KB, patch)
2007-06-07 20:41 EDT, David Somayajulu
no flags Details | Diff

  None (edit)
Description David Somayajulu 2007-06-05 21:36:50 EDT
Description of problem:
1. Data Overrun handling cleanup. There needs to be a check for Data overrun
generated by the HBA as well as by the target.

2. One can get a successful completion status from the HBA while the target
might indicate a data underrun (this can happen in a write). This condition
needs to be handled.

Version-Release number of selected component (if applicable):
RHEL5.1

How reproducible:


Steps to Reproduce:
1.
2.
3.
  
Actual results:


Expected results:


Additional info:
This patch assumes that the following patches have been already applied.

Bugzilla Bug 224203: [RHEL 5.1] qla4xxx/qla3xxx: co-existence issues during
load/unload of either interface (cont)
https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=224203

Bugzilla Bug 223087: qla4xxx: mutex_lock needs to be released before sleep() in
qla4xxx_mailbox_command
https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=223087

Bug 224435 Processed: [QLogic 5.1 feat] qla4xxx: Add support for IPV6, ioctl
module, QLE406x
https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=224435
Comment 1 David Somayajulu 2007-06-05 21:36:50 EDT
Created attachment 156299 [details]
patch to fix overrun/underrun handling
Comment 2 David Somayajulu 2007-06-05 21:38:09 EDT
I could not set the kernel version to 5.1, would appreciate if some one can.
Comment 3 Andrius Benokraitis 2007-06-05 22:46:02 EDT
David, this may not make the Beta. Will leave the final word to Mike/Tom.
Comment 5 David Somayajulu 2007-06-07 20:41:05 EDT
Created attachment 156533 [details]
Fix data overrun/underrun handling, also set AF_ONLINE condition fix.

Basically this adds patch adds one more fix which we discovered while testing
here. The HBA needs to brought ONLINE even if the Initiator IP address is not
set.  Please note this patch also includes the fixes for overrun/underrun
handling as before.
Comment 6 Andrius Benokraitis 2007-06-15 13:20:52 EDT
Proposing this bugzilla for post-Beta 5.1 inclusion.

David S/QLogic - is the severity correctly set to "low"?
Comment 7 David Somayajulu 2007-06-15 13:24:32 EDT
No it is not. It should be urgent in my opinion. I somehow could not change the
severity for some reason.
Comment 8 Andrius Benokraitis 2007-06-15 13:26:42 EDT
Hi David - thanks for the update.
Comment 9 RHEL Product and Program Management 2007-06-18 16:13:57 EDT
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 13 Andrius Benokraitis 2007-07-06 14:31:53 EDT
David - has this hit upstream yet?
Comment 14 David Somayajulu 2007-07-06 14:33:06 EDT
Yes it has.
Comment 15 Andrius Benokraitis 2007-07-06 14:42:02 EDT
Great! Mike, do you need the upstream commits or anything else from QLogic on this?
Comment 16 Mike Christie 2007-07-06 14:45:31 EDT
I can grab them from kernel.org for them.
Comment 17 Jay Turner 2007-07-26 09:37:47 EDT
Need the code, test results and a test plan before QE can weigh in on this
exception.
Comment 18 Marcus Barrow 2007-07-26 09:58:40 EDT
Perhaps Mike can better understands your request. The code is in the patch? I am uncertain
how one would force data under runs on a target for example - but perhaps that could
be done with a software target. Verifying the on-line status without an IP address should
be possible

An un-reported data-underrun is an important to fix.
Comment 19 Mike Christie 2007-07-26 10:59:00 EDT
(In reply to comment #17)
> Need the code, 

Code that was sent to rh-kernel is in the patch in comment #5.

I am not sure how to make underrun happen. We would have to hack a target to
force it to happen.

Ravi, how did you guys test this?
Comment 20 David Somayajulu 2007-08-14 15:25:36 EDT
This bugzilla has been marked POST. However I just downloaded
http://people.redhat.com/dzickus/el5/39.el5/src/kernel-2.6.18-39.el5.src.rpm 

and find that the enclosed patch in this bugzilla is not in yet. 

We really need the fix for turning AF_ONLINE bit on when the ip address is not
set on the HBA. Otherwise the SanSurfer/iscli application will not the see the
HBA. This is critical. 

A simplified version of this patch is 

diff -uarp
/usr/src/redhat/BUILD/kernel-2.6.18/linux-2.6.18.noarch/drivers/scsi/qla4xxx/ql4_init.c
./linux-2.6.18.noarch.39.el5/drivers/scsi/qla4xxx/ql4_init.c
---
/usr/src/redhat/BUILD/kernel-2.6.18/linux-2.6.18.noarch/drivers/scsi/qla4xxx/ql4_init.c
    2007-08-14 10:50:06.000000000 -0700
+++ ./linux-2.6.18.noarch.39.el5/drivers/scsi/qla4xxx/ql4_init.c       
2007-08-14 12:16:03.000000000 -0700
@@ -1181,8 +1181,10 @@ int qla4xxx_initialize_adapter(struct sc

        /* Skip device discovery if ip and subnet is zero */
        if (memcmp(ha->ip_address, ip_address, IP_ADDR_LEN) == 0 ||
-           memcmp(ha->subnet_mask, ip_address, IP_ADDR_LEN) == 0)
+           memcmp(ha->subnet_mask, ip_address, IP_ADDR_LEN) == 0) {
+               set_bit(AF_ONLINE, &ha->flags);
                return status;
+       }

        if (renew_ddb_list == PRESERVE_DDB_LIST) {
                /*
Comment 21 Marcus Barrow 2007-08-14 15:40:14 EDT
POST means it has been submited to the Red Hat kernel discussion list.
Status set to MODIFIED means it's been accepted.
I will ask about this right away...

Comment 22 Don Zickus 2007-08-15 15:09:04 EDT
in 2.6.18-40.el5
You can download this test kernel from http://people.redhat.com/dzickus/el5
Comment 24 John Poelstra 2007-08-24 01:26:30 EDT
A fix for this issue should have been included in the packages contained in the
most recent snapshot (partners.redhat.com) for RHEL5.1.  

Requested action: Please verify that your issue is fixed as soon as possible to
ensure that it is included in this update release.

After you (Red Hat Partner) have verified that this issue has been addressed,
please perform the following:
1) Change the *status* of this bug to VERIFIED.
2) Add *keyword* of PartnerVerified (leaving the existing keywords unmodified)

If this issue is not fixed, please add a comment describing the most recent
symptoms of the problem you are having and change the status of the bug to FAILS_QA.

More assistance: If you cannot access bugzilla, please reply with a message to
Issue Tracker and I will change the status for you.  If you need assistance
accessing ftp://partners.redhat.com, please contact your Partner Manager.
Comment 25 Andrius Benokraitis 2007-08-27 16:21:52 EDT
Mike - is this something that would be needed to be addressed in RHEL 4?
Comment 26 Mike Christie 2007-08-27 16:32:00 EDT
Marcus got it in his RHEL4 update already, right Marcus?
Comment 27 John Poelstra 2007-08-30 20:29:12 EDT
A fix for this issue should have been included in the packages contained in the
RHEL5.1-Snapshot4 on partners.redhat.com.  

Requested action: Please verify that your issue is fixed *as soon as possible*
to ensure that it is included in this update release.

After you (Red Hat Partner) have verified that this issue has been addressed,
please perform the following:
1) Change the *status* of this bug to VERIFIED.
2) Add *keyword* of PartnerVerified (leaving the existing keywords unmodified)

If this issue is not fixed, please add a comment describing the most recent
symptoms of the problem you are having and change the status of the bug to FAILS_QA.

If you cannot access bugzilla, please reply with a message to Issue Tracker and
I will change the status for you.  If you need assistance accessing
ftp://partners.redhat.com, please contact your Partner Manager.
Comment 28 John Poelstra 2007-09-11 15:22:40 EDT
A fix for this issue should have been included in the packages contained in the
RHEL5.1-Snapshot6 on partners.redhat.com.  

Requested action: Please verify that your issue is fixed ASAP to confirm that it
will be included in this update release.

After you (Red Hat Partner) have verified that this issue has been addressed,
please perform the following:
1) Change the *status* of this bug to VERIFIED.
2) Add *keyword* of PartnerVerified (leaving the existing keywords unmodified)

If this issue is not fixed, please add a comment describing the most recent
symptoms of the problem you are having and change the status of the bug to FAILS_QA.

If you cannot access bugzilla, please reply with a message to Issue Tracker and
I will change the status for you.  If you need assistance accessing
ftp://partners.redhat.com, please contact your Partner Manager.
Comment 29 Marcus Barrow 2007-09-12 12:38:28 EDT
Verified in kernel-2.6.18-46.el5.src.rpm
Comment 31 errata-xmlrpc 2007-11-07 14:51:45 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2007-0959.html

Note You need to log in before you can comment on or make changes to this bug.